SystemOrganization addCategory: #GhostProxies!

!CompiledMethod class methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 6/20/2011 11:16'!
receiver: aReceirver withArgs: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and args in argArray"

	<primitive: 188>
	self primitiveFailed! !

!Behavior methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 5/17/2011 17:09'!
methodDict
	methodDict == nil ifTrue: [^ self emptyMethodDictionary ].
	^ methodDict! !

Object subclass: #ClassProxy
	instanceVariableNames: 'superclass methodDict format target handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ClassProxy class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/20/2012 16:37'!
createProxyAndReplace: aClassThenProxy
   | aProxyThenClass |
       aProxyThenClass := self new
		initializeWith: SimpleForwarderHandler new
       	methodDict: nil
       	superclass: InstanceClassProxy
       	format: InstanceClassProxy format.
       aProxyThenClass become: aClassThenProxy.
        "After the become is done, aProxyThenObject now points
	 to the original object, and  anObjectThenProxy points to 
	the proxy"
       aClassThenProxy target: aProxyThenClass.
	ClassProxyTrap initialize.
       ClassProxyTrap adoptInstance: aClassThenProxy.
       ^ aClassThenProxy.
! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/20/2012 16:37'!
cannotInterpret: aMessage
       ^ handler handleInterception: aMessage for: target proxy: self! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 11:53'!
initializeWith: aHandler methodDict: aMethodDict superclass: aClass format: aFormat
	super initialize.
	handler := aHandler.
	methodDict := aMethodDict.
	superclass := aClass.
	format := aFormat.! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
target: anObject
	target := anObject! !

ClassProxy subclass: #ClassProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ClassProxyTrap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 13:30'!
initialize
	superclass := ClassProxy.
	format := ClassProxy format.
	methodDict := nil.! !

Object subclass: #InstanceClassProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!InstanceClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/20/2012 20:13'!
cannotInterpret: aMessage
	^ aMessage lookupClass handleInterceptionToInstance: aMessage andReceiver: self
! !

Object subclass: #Interception
	instanceVariableNames: 'message receiver target proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!Interception class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:53'!
for: aMessage target: aTargetObject proxy: aProxy receiver: aReceiver
	^ self new initializewith: aMessage 
		target: aTargetObject
		proxy: aProxy 
		receiver: aReceiver ! !

!Interception methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:39'!
initializewith: aMessage target: aTargetObject proxy: aProxy  receiver: aReceiver 
	message := aMessage.
	target := aTargetObject.
	proxy := aProxy.
	receiver := aReceiver.! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message
	^ message! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message: anObject
	message := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy
	^ proxy! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy: anObject
	proxy := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver
	^ receiver! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver: anObject
	receiver := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target
	^ target! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target: anObject
	target := anObject! !

Object subclass: #ObjectProxy
	instanceVariableNames: 'target handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxy class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/20/2012 14:37'!
createProxyAndReplace: anObjectThenProxy
   | aProxyThenObject |
       aProxyThenObject := self new
		initializeWith: anObjectThenProxy
		handler: SimpleForwarderHandler new. 
       aProxyThenObject become: anObjectThenProxy.
        "After the become is done, aProxyThenObject now points
	 to the original object, and  anObjectThenProxy points to 
	the proxy"
       anObjectThenProxy target: aProxyThenObject.
	ObjectProxyTrap initialize.
       ObjectProxyTrap adoptInstance: anObjectThenProxy.
       ^ anObjectThenProxy.
! !

!ObjectProxy class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/22/2011 16:30'!
createProxyAndReplaceMethod: aMethod
	 | aProxy |
       aProxy := self new
		initializeWith: aMethod
		handler: SimpleForwarderHandler new. 
	aMethod methodClass methodDict at: aMethod selector put: aProxy.
	 ObjectProxyTrap initialize.
       ObjectProxyTrap adoptInstance: aProxy.
       ^ aProxy.! !

!ObjectProxy class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 11:55'!
proxyFor: anObject
	 | aProxy |
       aProxy := self new
		initializeWith: anObject
		handler: SimpleForwarderHandler new. 
	 ObjectProxyTrap initialize.
       ObjectProxyTrap adoptInstance: aProxy.
       ^ aProxy.! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:46'!
cannotInterpret: aMessage
       ^ handler handleInterception: aMessage for: target proxy: self! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 11:56'!
initializeWith: anObject handler: aHandler
	target := anObject.
	handler := aHandler  
	! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/22/2011 16:29'!
target: aTargetObject
	target := aTargetObject ! !

ObjectProxy subclass: #ObjectProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxyTrap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 10:58'!
initialize
	superclass := ObjectProxy.
	format := ObjectProxy format.
	methodDict := nil.! !

Object subclass: #ObjectProxyDNU
	instanceVariableNames: 'target handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxyDNU class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 5/26/2011 13:21'!
proxyFor: anObject
	 | aProxy |
       aProxy := self new
		initializeWith: anObject
		handler: SimpleForwarderHandler new. 
       ^ aProxy.! !

!ObjectProxyDNU methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 5/26/2011 13:24'!
doesNotUnderstand: aMessage
       ^ handler handleInterception: aMessage for: target proxy: self  ! !

!ObjectProxyDNU methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 5/26/2011 13:21'!
initializeWith: anObject handler: aHandler
	target := anObject.
	handler := aHandler  
	! !

Object subclass: #SimpleForwarderHandler
	instanceVariableNames: 'methodsNotToIntercept'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!SimpleForwarderHandler methodsFor: 'handle - class proxy' stamp: 'MarianoMartinezPeck 6/20/2011 10:42'!
classProxyMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #handleInterceptionToInstance:andReceiver:  put: #handleInterceptionToInstanceFor:.
	^ dict
! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:17'!
debuggingMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #basicInspect put:#handleBasicInspect:.
	dict at: #inspect put:#handleInspect:.
	dict at: #inspectorClass put:#handleInspectorClass:.
	dict at: #defaultLabelForInspector put:#handleDefaultLabelForInspector:.
	dict at: #printStringLimitedTo: put: #handlePrintStringLimitedTo:.
	dict at: #printString put: #handlePrintString:.
	dict at: #longPrintOn:limitedTo:indent: put: #handleLongPrintOnLimitedToIndent:.
	^ dict	! !

!SimpleForwarderHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 6/20/2011 10:16'!
defaultMethodsNotToIntercept
	| dict |
	dict := Dictionary new.
	dict addAll: self methodsMessagesToHandle.
	dict addAll: self debuggingMessagesToHandle.
	dict addAll: self testSupportMessagesToHandle.
	dict addAll: self classProxyMessagesToHandle.
	^ dict
	
	! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 11/29/2011 09:56'!
handleBasicInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the 
	receiver's variables. This method should not be overriden."
	^Smalltalk tools basicInspect: anInterception proxy! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:13'!
handleDefaultLabelForInspector: anInterception
	^ 'Proxy'! !

!SimpleForwarderHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 4/22/2011 11:11'!
handleFlushCache: anInterception
	^ anInterception target selector flushCache	 
		! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 11/29/2011 09:56'!
handleInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the receiver's variables."
	Smalltalk tools inspect: anInterception proxy! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:08'!
handleInspectorClass: anInterception
	"Answer the class of the inspector to be used on the receiver.  Called by inspect; 
	use basicInspect to get a normal (less useful) type of inspector."

	^ Inspector! !

!SimpleForwarderHandler methodsFor: 'handle - API' stamp: 'MarianoMartinezPeck 9/1/2011 16:26'!
handleInterception: aMessage for: aTargetObject proxy: proxy
	| interception |
	"WHEN BENCHMARKING remove all this method and just let 
	^ aMessage sendTo: aTargetObject."
	self log:  'message ', aMessage selector, ' intercepted'.
	interception := Interception for: aMessage target: aTargetObject proxy: proxy receiver: nil. 
	(self isMessageNotToIntercept: aMessage)
		ifTrue: [ ^ self manageMessageInternally: interception ]
	 	ifFalse: [ ^ self manageMessage: interception  ]! !

!SimpleForwarderHandler methodsFor: 'handle - API' stamp: 'MarianoMartinezPeck 9/1/2011 16:02'!
handleInterceptionToInstance: aMessage for: aClass andReceiver: anInstance

	self log: 'message ', aMessage selector, ' to instance intercepted and will be forwarded'.
	^ CompiledMethod receiver: anInstance withArgs: aMessage arguments  executeMethod:  (aClass lookupSelector: aMessage selector) 
	! !

!SimpleForwarderHandler methodsFor: 'handle - class proxy' stamp: 'MarianoMartinezPeck 6/20/2011 11:20'!
handleInterceptionToInstanceFor: anInterception

	^ self handleInterceptionToInstance: anInterception message arguments first for: anInterception target  andReceiver: anInterception message arguments second 
! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:08'!
handleLongPrintOnLimitedToIndent: anInterception
	! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:09'!
handleLongPrintStringLimitedTo: anInterception
	^ 'This is a proxy'! !

!SimpleForwarderHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 9/1/2011 16:03'!
handleMethodExecution: anInterception
	self log: 'message ', anInterception message selector, ' execution intercepted and will be forwarded'.
	^ anInterception target valueWithReceiver: anInterception message arguments third arguments: anInterception message arguments second
	
! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:31'!
handlePrintOn: anInterception
	anInterception message arguments first nextPutAll: 'aProxy'  ! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:09'!
handlePrintString: anInterception
	^ anInterception proxy printStringLimitedTo: 50000! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:09'!
handlePrintStringLimitedTo: anInterception
	^ 'This is the print of a proxy'! !

!SimpleForwarderHandler methodsFor: 'handle - support' stamp: 'MarianoMartinezPeck 9/1/2011 16:03'!
handleUninstall: anInterception

	self log: 'message ', anInterception message selector, ' received and the proxy will be uninstalled'.
	^ anInterception target become: anInterception proxy.
	! !

!SimpleForwarderHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/21/2011 13:48'!
isMessageNotToIntercept: aMessage
	^ self methodsNotToIntercept includesKey: aMessage selector  ! !

!SimpleForwarderHandler methodsFor: 'logging' stamp: 'MarianoMartinezPeck 9/1/2011 16:04'!
log: aString
	"Transcript show: aString; cr."! !

!SimpleForwarderHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 9/1/2011 16:03'!
manageMessage: interception
	self log: 'The method ', interception message selector, ' will beforwarded'.
	^ interception message sendTo: interception target! !

!SimpleForwarderHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 9/1/2011 16:03'!
manageMessageInternally: anInterception 
	self log: 'The method ', anInterception message selector, ' will NOT be forwarded by instead answer by the handler'.
	^ self perform: (self methodsNotToIntercept at: anInterception message selector) with: anInterception ! !

!SimpleForwarderHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 1/20/2012 20:13'!
methodsMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #flushCache put: #handleFlushCache:.
	dict at: #run:with:in: put: #handleMethodExecution:.
	^ dict
! !

!SimpleForwarderHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/21/2011 13:29'!
methodsNotToIntercept
	methodsNotToIntercept isNil ifTrue: [ methodsNotToIntercept := self defaultMethodsNotToIntercept ].
	^ methodsNotToIntercept ! !

!SimpleForwarderHandler methodsFor: 'handle - support' stamp: 'MarianoMartinezPeck 4/22/2011 11:18'!
testSupportMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #uninstall put: #handleUninstall:.
	^ dict 
	! !
ClassProxyTrap initialize!
ObjectProxyTrap initialize!
